<?php

namespace QUI\UserDownloads;

use QUI;
use QUI\ERP\Products\Product\Types\DigitalProduct;
use QUI\Locale;

/**
 * A digital download product that can be accessed as long as the buyer is in a membership
 */
class DownloadMembershipProductType extends QUI\ERP\Plans\PlanProduct
{
    /**
     * @param QUI\Locale|null $Locale
     * @return string
     */
    public static function getTypeTitle(null | QUI\Locale $Locale = null): string
    {
        if ($Locale === null) {
            $Locale = QUI::getLocale();
        }

        return $Locale->get('quiqqer/user-downloads', 'product_type.DownloadMembershipProductType.title');
    }

    /**
     * @param Locale|null $Locale
     * @return string
     */
    public static function getTypeDescription(null | QUI\Locale $Locale = null): string
    {
        if ($Locale === null) {
            $Locale = QUI::getLocale();
        }

        return $Locale->get('quiqqer/user-downloads', 'product_type.DownloadMembershipProductType.description');
    }

    public static function isTypeSelectable(): bool
    {
        return Handler::canUseDownloadMembershipProducts();
    }
}
